<template>
  <v-dialog v-model="dialog" max-width="500">
    <v-card>
      <v-card-title class="headline">Empty Card</v-card-title>

      <v-card-text>
        <v-form v-model="valid">
          <v-list>
            <find-card :number="number" v-model="card" :visible="dialog"/>
            <v-currency-field
              label="Current Credits"
              v-bind="currency_config"
              v-model="money"
              disabled
              v-if="this.card"
            />
            <v-currency-field
              label="Final Credits"
              v-bind="currency_config"
              v-model="finalMoney"
              disabled
              v-if="this.card"
            />
          </v-list>
        </v-form>
      </v-card-text>

      <v-card-actions>
        <v-spacer></v-spacer>

        <v-btn color="red darken-1" flat="flat" @click="dialog = false" :loading="loading">Cancel</v-btn>
        <v-btn
          color="green darken-1"
          flat="flat"
          @click="addCredits(); dialog = false"
          :loading="loading"
        >Agree</v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
import gql from "graphql-tag";
import { QrcodeStream } from "vue-qrcode-reader";
import FindCard from "@/components/FindCard";

export default {
  components: { QrcodeStream, FindCard },
  props: {
    number: Number
  },
  data() {
    return {
      card: null,
      valid: null,
      dialog: false,
      loading: false,
      currency_config: {
        decimal: ",",
        thousands: ".",
        prefix: "R$ ",
        precision: 2,
        masked: false,
        allowBlank: false,
        min: Number.MIN_SAFE_INTEGER,
        max: Number.MAX_SAFE_INTEGER
      }
    };
  },
  computed: {
    money() {
      return this.card && this.card.money / 100;
    },
    finalMoney() {
      return 0;
    }
  },
  methods: {
    open() {
      this.dialog = true;
    },
    async addCredits() {
      this.loading = true;

      try {
        await this.$apollo.mutate({
          mutation: gql`
            mutation($cardNumber: Int!) {
              emptyCredits(cardNumber: $cardNumber) {
                id
              }
            }
          `,
          variables: {
            cardNumber: (this.card && this.card.number) || this.number
          }
        });
      } catch (e) {
        console.error(e);
      } finally {
        this.loading = false;
      }
    }
  }
};
</script>
